package eu.mhsl.craftattack.spawn.appliances.chatMention;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import eu.mhsl.craftattack.spawn.util.text.ComponentUtil;
import io.papermc.paper.event.player.AsyncChatDecorateEvent;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.serializer.plain.PlainTextComponentSerializer;
import org.bukkit.event.EventHandler;

import java.util.ArrayList;
import java.util.List;

public class ChatMentionListener extends ApplianceListener<ChatMention> {
    @SuppressWarnings("UnstableApiUsage")
    @EventHandler
    public void coloringEvent(AsyncChatDecorateEvent event) {
        String message = PlainTextComponentSerializer.plainText().serialize(event.result());
        List<String> words = List.of(message.split(" "));
        List<String> mentioned = new ArrayList<>();

        ChatMentionSetting.ChatMentionConfig config = Settings.instance()
            .getSetting(event.player(), Settings.Key.ChatMentions, ChatMentionSetting.ChatMentionConfig.class);

        Component result = words.stream()
            .map(word -> {
                String wordWithoutAnnotation = word.replace("@", "");
                boolean isPlayer = getAppliance().getPlayerNames().contains(wordWithoutAnnotation);
                if(isPlayer && config.applyMentions()) {
                    mentioned.add(wordWithoutAnnotation);
                    return Component.text(
                        getAppliance().formatPlayer(wordWithoutAnnotation),
                        NamedTextColor.GOLD
                    );
                } else {
                    return Component.text(word);
                }
            })
            .reduce(ComponentUtil::appendWithSpace)
            .orElseThrow();

        getAppliance().notifyPlayers(mentioned);
        event.result(result);
    }
}
